/*
 * main_simple.c
 *
 *  Created on: 03.09.2009
 *      Author: daniel
 */

/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *	Autor: Daniel R.
 */

#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/io.h>

#include "main.h"
#include "file.h"
#include "fat.h"
#include "mmc.h"		// hardware abhängig
#include "uart.h"		// hardware abhängig


//*****************************************************************************************************************
void main(void){

	uinit();							// uart initialisierung


	uputs((unsigned char*)"\nBoot");

	while (mmc_init() !=0){ 				// rückgabewert 0 dann ist karte initialisiert
		nop();
	}

	uputs((unsigned char*)"...");

	if(0==fat_loadFatData()){				// rückgabewert 0 dann sind die fat daten bekannt

		uputs((unsigned char*)"Ok\n");	// wenn auf dem terminal "Boot... OK" zu lesen ist, ist init ok. jetzt kann man schreiben/lesen

		unsigned char c;
		unsigned long int seek;
		unsigned char file_name[12]="TEST    TXT";

		seek=26;
		c='a';

		// rückgabewert 2 bedeutet, datei ist nicht vorhanden und wurde grade angelegt. bereit zum schreiben !
		if(2==ffopen(file_name)){
			do{
				ffwrite(c++);
			}while(--seek);

			// zeilenumbruch in der datei
			ffwrite(0x0D);
			ffwrite(0x0A);

			ffclose();
		}

		// hier ist rückgabewerte eigentlich 1, datei ist vorhanden und wurde geöffnet. bereit zum lesen !
		else{

			ffopen(file_name);
			seek=file.length;

			do{
				c=ffread();
				uputc(c);
			}while(--seek);

			ffclose();
		}
	}
}









